include dfrntnd1.e
include dfrntnd2.e
include dfrntnd3.e
include dfrntnd4.e

without warning

global constant VideoMem = #B8000,
		Version = "v2.0",
		FALSE = 0,
		TRUE = not FALSE,
		GameName = 1,
		GOBName = 2,
		LFDName = 3,
		CRAWLName = 4,
		OtherNum = 5,
		Others = 6,
		NumTitles = 15

global sequence DarkDir, LFDDir, LevelsDir, DFGameData, cmd, Wallpaper,
    PaperFile
DarkDir = "C:\\DARK"
LFDDir = "C:\\DARK\\LFD"
LevelsDir = "C:\\DARK\\LEVELS"

DFGameData = {{"Dark Forces", "۲Dark", "", "", 0}}
cmd = command_line()
PaperFile = "DFRNTEND.SRN"

function LoadSRN(sequence filename)
    integer fn
    sequence woohoo, stuff
    fn = open(filename, "rb")
    
    if fn = -1 then
	return {0}
    end if
    
    woohoo = {getc(fn), getc(fn), getc(fn)}
    if compare(woohoo, "GOD") then
	return {0}
    end if

    stuff = {}
    for i = 1 to (80 * 25) do
	woohoo = {getc(fn), getc(fn)}
	stuff &= woohoo[2]
	stuff &= woohoo[1]
    end for

    close(fn)

    return stuff
end function

function trim(sequence Text)
    for i = 1 to length(Text) do
	if Text[i] != 32 then
	    for j = length(Text) to 1 by -1 do
		if Text[i] != 32 then
		    return(Text[i..j])
		end if
	    end for
	    return(Text[i..length(Text)])
	end if
    end for
    return(Text)
end function

function CMDFind(sequence param)
    sequence thingys
    thingys = {"", "/", "-"}

    for j = 1 to length(thingys) do
	for i = 1 to length(cmd) do
	    if not compare(trim(upper(cmd[i])), thingys[j] &
		trim(upper(param))) then
		
		return i
	    end if
	end for
    end for

    return 0
end function

procedure Center(sequence Text, integer c3, integer c2, integer c1)
    sequence temp
    temp = get_position()

    text_color(c1)
    position(temp[1], floor((80 - length(Text)) / 2))
    puts(2, Text[1])
    text_color(c2)
    puts(2, Text[2])
    text_color(c3)
    puts(2, Text[3..length(Text) - 2])
    text_color(c2)
    puts(2, Text[length(Text) - 1])
    text_color(c1)
    puts(2, Text[length(Text)])
end procedure

procedure Error(integer Num)
    sound(500)
    text_color(12)
    if Num = 32767 then
	puts(2, "Could not open DFRNTEND.INI\n")
    elsif Num = 31000 then
	puts(2, "Could not find correct section in INI.\n")
    elsif Num = 31001 then
	puts(2, "Could not find correct key in INI.\n")
    else
	puts(2, "Could not read INI.\n")
    end if
    text_color(7)
    sound(0)
    abort(1)
end procedure

function INIRead(integer fn, sequence Section, sequence Key)
    object temp
    sequence temp2

    if seek(fn, 0) then end if
    temp = {}
    while compare(trim(upper(temp)), "[" & upper(Section) & "]") do
	temp = gets(fn)
	if not compare(temp, -1) then
	    Error(31000)
	end if
	while not compare(temp[length(temp)], 13)
	    or not compare(temp[length(temp)], 10) do
	    
	    temp = temp[1..length(temp) - 1]
	end while
    end while
    while 1 do
	temp = gets(fn)
	if not compare(temp, -1) then
	    Error(31001)
	else
	    temp2 = trim(temp)
	    if not compare(temp2[1], "[") then
		Error(31001)
	    end if
	end if
	while not compare(temp[length(temp)], 13)
	    or not compare(temp[length(temp)], 10) do
	    
	    temp = temp[1..length(temp) - 1]
	end while
	if find('=', temp) and not compare(trim(upper(temp[1..find('=', temp)
	    - 1])), upper(Key)) then

	    temp2 = trim(temp)
	    while not compare(temp2[length(temp2)], 13)
		or not compare(temp2[length(temp2)], 10) do

		temp2 = temp2[1..length(temp2) - 1]
	    end while
	    return(temp2[find('=', temp2) + 1..length(temp)])
	end if
    end while
end function

procedure DrawTitleBar(integer Num)
    position(1, 1)
    text_color(15)
    bk_color(1)
    puts(2, repeat(' ', 80))
    position(1, 1)
    if Num = 0 then
	Center("Dark Frontend " & Version, 15, 7, 8)
    elsif Num = 1 then
	Center("Dark Frontend " & Version & " - Pre-Run Tests", 15, 7, 8)
    elsif Num = 2 then
	Center("Dark Frontend " & Version & " - Loading Files", 15, 7, 8)
    elsif Num = 3 then
	Center("Thank you for using Dark Frontend " & Version & "!", 15, 7, 8)
    elsif Num = 4 then
	Center("Dark Frontend " & Version & " - Preparing to run Dark Forces",
	    15, 7, 8)
    end if
end procedure

function exist(sequence filename)
    integer fn

    fn = open(filename, "rb")
    if fn = -1 then
	return(FALSE)
    else
	close(fn)
	return(TRUE)
    end if
end function

function GetDirs(sequence path_name, sequence entry)
    if find('d', entry[D_ATTRIBUTES]) and exist(LevelsDir & "\\" & entry[D_NAME]
	& "\\" & entry[D_NAME] & ".INI")then
	
	DFGameData = append(DFGameData, {"", entry[D_NAME], "", "", 0})
    end if
    return 0
end function

function lesslen(sequence a, sequence b)
    if length(a) < length(b) then
	return length(a)
    end if
    return length(b)
end function

procedure SortGames()
    sequence temp

    for i = 1 to length(DFGameData) do
	if not compare(DFGameData[i][GOBName], "۲Dark") then
	    temp = DFGameData[i]
	    DFGameData[i] = DFGameData[1]
	    DFGameData[1] = temp
	    exit
	end if
    end for
    for i = length(DFGameData) to 2 by -1 do
	for j = 2 to i - 1 do
	    if compare(trim(DFGameData[j][GameName]),
		trim(DFGameData[j + 1][GameName])) then
		
		for k = 1 to lesslen(trim(DFGameData[j][GameName]),
		    trim(DFGameData[j + 1][GameName]))  do
		    
		    if lower(DFGameData[j][GameName][k]) >
			lower(DFGameData[j + 1][GameName][k]) then
			
			temp = DFGameData[j]
			DFGameData[j] = DFGameData[j + 1]
			DFGameData[j + 1] = temp
			exit
		    end if
		    if lower(DFGameData[j][GameName][k]) <
			lower(DFGameData[j + 1][GameName][k]) then
			
			exit
		    end if
		    if k = lesslen(trim(DFGameData[j][GameName]),
			trim(DFGameData[j + 1][GameName])) then
			
			temp = DFGameData[j]
			DFGameData[j] = DFGameData[j + 1]
			DFGameData[j + 1] = temp
		    end if
		end for
	    end if
	end for
    end for
end procedure

procedure DrawOpStuff()
    text_color(7)
    bk_color(0)
    position(8, 25)
    printf(2, "%s", {DarkDir})
    position(11, 25)
    printf(2, "%s", {LFDDir})
    position(14, 25)
    printf(2, "%s", {LevelsDir})
    text_color(0)
    bk_color(1)
    position(16, 34)
    puts(2, "͸")
    position(17, 34)
    puts(2, "           ")
    text_color(10)
    position(17, 36)
    puts(2, 17 & "       " & 16)
    text_color(15)
    position(17, 38)
    puts(2, "Close")
    text_color(0)
    position(18, 34)
    puts(2, ";")
end procedure

procedure WriteFile()
    integer fn
    fn = open("DFRNTEND.INI", "wb")
    printf(fn, "[Main]\nDarkDir=%s\nLFDDir=%s\nLevelsDir=%s",
	{DarkDir, LFDDir, LevelsDir})
    close(fn)
end procedure

function LimitInput(integer len, sequence value)
    integer i, Key
    sequence temp, tmp2, orig
    temp = value
    orig = get_position()

    cursor(UNDERLINE_CURSOR)
    printf(2, "%s", {value})
    i = 0
    while 1 do
	Key = -1
	while Key = -1 do
	    Key = get_key()
	end while
	if Key >= 32 and Key <= 254 then
	    if length(temp) < len then
		temp &= Key
		printf(2, "%s", {Key})
		if length(temp) = len then
		    cursor(NO_CURSOR)
		end if
	    end if
	elsif Key = 8 then
	    if length(temp) > 0 then
		temp = temp[1..length(temp) - 1]
		tmp2 = get_position()
		position(tmp2[1], tmp2[2] - 1)
		puts(2, " ")
		position(tmp2[1], tmp2[2] - 1)
		if length(temp) = len - 1 then
		    cursor(UNDERLINE_CURSOR)
		end if
	    end if
	elsif Key = 13 then
	    exit
	elsif Key = 27 then
	    position(orig[1], orig[2])
	    puts(2, value)
	    cursor(NO_CURSOR)
	    return(value)
	end if
    end while
    cursor(NO_CURSOR)
    return(temp)
end function

procedure DoShadow(integer x, integer y, integer num)
    integer wow, hmm

    for i = 0 to num - 1 do
	wow = peek(VideoMem + (160 * (y - 1)) + (2 * (x - 1 + i)) + 1)
	if wow >= 128 then
	    wow -= 128
	else
	    while wow >= 16 do
		wow -= 16
	    end while
	end if
	if wow >= 8 and wow <= 15 then
	    wow -= 8
	else
	    hmm = wow
	    while hmm >= 16 do
		hmm -= 16
	    end while
	    wow -= hmm
	end if
	poke(VideoMem + (160 * (y - 1)) + (2 * (x - 1 + i)) + 1, wow)
    end for
end procedure

procedure MakeWindow(integer x1, integer y1, integer x2, integer y2, integer c1,
    integer c2)
    
    text_color(c1)
    bk_color(c2)
    position(y1, x1)
    puts(2, "" & repeat('', x2 - x1 - 1) & "")
    for i = 1 to y2 - y1 do
	text_color(c1)
	bk_color(c2)
	position(i + y1, x1)
	puts(2, "" & repeat(' ', x2 - x1 - 1) & "")
	DoShadow(x2 + 1, i + y1, 2)
    end for
    text_color(c1)
    bk_color(c2)
    position(y2, x1)
    puts(2, "" & repeat('', x2 - x1 - 1) & "")
    DoShadow(x1 + 2, y2 + 1, x2 - x1 + 1)
    text_color(c1)
    bk_color(c2)
end procedure

procedure Options()
    integer i, j, k, Key

    MakeWindow(23, 6, 56, 19, 15, 1)
    text_color(14)
    bk_color(1)
    position(7, 24)
    puts(2, "< ")
    text_color(12)
    puts(2, "DARK FORCES DIRECTORY")
    text_color(14)
    puts(2, " >Ŀ")
    position(8, 24)
    puts(2, "                              ")
    position(9, 24)
    puts(2, "")
    text_color(7)
    bk_color(0)
    position(8, 25)
    puts(2, "                              ")
    text_color(14)
    bk_color(1)
    position(10, 24)
    puts(2, "< ")
    text_color(12)
    puts(2, "DARK FORCES LFD DIRECTORY")
    text_color(14)
    puts(2, " >Ŀ")
    position(11, 24)
    puts(2, "                              ")
    position(12, 24)
    puts(2, "")
    text_color(7)
    bk_color(0)
    position(11, 25)
    puts(2, "                              ")
    text_color(14)
    bk_color(1)
    position(13, 24)
    puts(2, "< ")
    text_color(12)
    puts(2, "ADD-ON LEVELS DIRECTORY")
    text_color(14)
    puts(2, " >Ŀ")
    position(14, 24)
    puts(2, "                              ")
    position(15, 24)
    puts(2, "")
    text_color(7)
    bk_color(0)
    position(14, 25)
    puts(2, "                              ")
    DrawOpStuff()
    k = 0
    i = 0
    while 1 do
	if i = 0 then
	    k = 0
	    text_color(15)
	    bk_color(0)
	    position(8, 25)
	    puts(2, DarkDir)
	elsif i = 1 then
	    k = 0
	    text_color(15)
	    bk_color(0)
	    position(11, 25)
	    puts(2, LFDDir)
	elsif i = 2 then
	    k = 0
	    text_color(15)
	    bk_color(0)
	    position(14, 25)
	    puts(2, LevelsDir)
	elsif i = 3 then
	    if k != 3 then
		k = 3
		text_color(14)
		bk_color(1)
		position(16, 34)
		puts(2, "͸")
		position(17, 34)
		puts(2, "           ")
		text_color(10)
		position(17, 36)
		puts(2, 17 & "       " & 16)
		text_color(15)
		position(17, 38)
		puts(2, "CLOSE")
		text_color(14)
		position(18, 34)
		puts(2, ";")
	    end if
	end if
	Key = get_key()
	if Key = 328 then
	    i -= 1
	    if i = -1 then
		i = 3
	    end if
	    DrawOpStuff()
	elsif Key = 336 then
	    i += 1
	    if i = 4 then
		i = 0
	    end if
	    DrawOpStuff()
	elsif Key = 27 then
	    WriteFile()
	    return
	elsif Key = 13 or Key = 32 then
	    if i = 3 then
		WriteFile()
		return
	    elsif i = 2 then
		text_color(15)
		bk_color(0)
		position(14, 25)
		LevelsDir = LimitInput(30, LevelsDir)
	    elsif i = 1 then
		text_color(15)
		bk_color(0)
		position(11, 25)
		LFDDir = LimitInput(30, LFDDir)
	    elsif i = 0 then
		text_color(15)
		bk_color(0)
		position(8, 25)
		DarkDir = LimitInput(30, DarkDir)
	    end if
	end if
    end while
end procedure

function SaveScreen()
    sequence temp, temp2

    temp = peek({VideoMem, 4000})
    temp2 = get_position()

    return {temp, temp2}
end function

procedure RestoreScreen(sequence screen)
    poke(VideoMem, screen[1])
    position(screen[2][1], screen[2][2])
end procedure

procedure ScreenTests()
    object temp, temp2
    integer TestFailed, fn
    
    TestFailed = FALSE
    DrawTitleBar(1)
    text_color(7)
    bk_color(0)
    if peek(VideoMem + 160) != 32 and peek(VideoMem + 160) != 0 and
	peek(VideoMem + 160) != 255 then
	
	TestFailed = TRUE
    end if
    puts(1, "\nTesting for color monitor (you DO have one... right?!?)...\n")
    if peek(VideoMem + 160) != 84 then
	TestFailed = TRUE
    end if
    if TestFailed then
	sound(500)
	text_color(12)
	puts(2, "Address &HB800 does not contain video memory.  Dark Frontend\n")
	puts(2, "requires video memory to run.  If you are running a DOS\n")
	puts(2, "emulator or are using a monochrome monitor, this could\n")
	puts(2, "explain this error. Run DFRNTEND in real DOS and with a color\n")
	puts(2, "system.\n")
	sound(0)
	text_color(7)
	abort(1)
    end if
    puts(1, "Video memory at [&HB800:0000-3999].  Yippee!\n")
    clear_screen()
    DrawTitleBar(2)
    text_color(7)
    bk_color(0)
    puts(1, "\nOpening DFRNTEND.INI... I hope it\'s in the current dir!\n")
    
    fn = open("DFRNTEND.INI", "rb")
    if fn = -1 then
	temp = SaveScreen()
	Options()
	RestoreScreen(temp)
	text_color(7)
	bk_color(0)
    else
	temp = get(fn)
	if compare(temp[1], GET_EOF) then
	    if seek(fn, 0) then end if
	    DarkDir = INIRead(fn, "Main", "DarkDir")
	    LFDDir = INIRead(fn, "Main", "LFDDir")
	    LevelsDir = INIRead(fn, "Main", "LevelsDir")
	else
	    temp = SaveScreen()
	    Options()
	    RestoreScreen(temp)
	    text_color(7)
	    bk_color(0)
	end if
	close(fn)
    end if
    
    puts(1, "Getting game list...\n")
    if walk_dir(LevelsDir, routine_id("GetDirs"), FALSE) then end if
    
    for j = 1 to length(DFGameData) do
	if compare(DFGameData[j][GOBName], "۲Dark") then
	    if not compare(get_position(), {25, 1}) then
		scroll(1, 2, 25)
		position(24, 1)
	    end if
	    printf(1, "Opening and reading %s...",
		{DFGameData[j][GOBName]})
	    puts(1, repeat(' ', 80 - (23 + length(DFGameData[j][GOBName]))))
	    fn = open(LevelsDir & "\\" & DFGameData[j][GOBName] & "\\" &
		DFGameData[j][GOBName] & ".INI", "rb")
	    if fn = -1 then
		text_color(12)
		printf(2, "\nCould not open .INI file for %s.",
		    {DFGameData[j][GOBName]})
		text_color(7)
	    else
		DFGameData[j][GameName] = INIRead(fn, DFGameData[j][GOBName],
		    "GameName")
		DFGameData[j][LFDName] = INIRead(fn, DFGameData[j][GOBName],
		    "LFDName")
		DFGameData[j][CRAWLName] = INIRead(fn, DFGameData[j][GOBName],
		    "CRAWLName")
		temp = value(INIRead(fn, DFGameData[j][GOBName],
		    "Others"))
		DFGameData[j][OtherNum] = temp[2]
		for k = 1 to DFGameData[j][OtherNum] do
		    DFGameData[j] &= {INIRead(3, DFGameData[j][GOBName], "Other"
			& sprintf("%d", {k - 1}))}
		end for
	    close(fn)
	    end if
	    temp = get_position()
	    position(temp[1] - 1, 1)
	end if
    end for
    temp2 = 1
    while temp2 <= length(DFGameData) do
	if not compare(DFGameData[temp2][GameName], "") then
	    DFGameData = DFGameData[1..temp2 - 1] &
		DFGameData[temp2 + 1..length(DFGameData)]
	    temp2 -= 1
	end if
	temp2 += 1
    end while
    position(temp[1], 1)
    if not compare(get_position(), {25, 1}) then
	scroll(1, 2, 25)
	position(24, 1)
    end if
    puts(1, "Sorting game list alphabetically...\n")
    SortGames()
    if not compare(get_position(), {25, 1}) then
	scroll(1, 2, 25)
	position(24, 1)
    end if
    puts(1, "Checking for Dark Frontend crash...\n")
    if exist(LFDDir & "DFBRIEF.DFE") then
	if not compare(get_position(), {25, 1}) then
	    scroll(1, 2, 25)
	    position(24, 1)
	end if
	puts(1, "Restoring DFBRIEF.LFD...\n")
	if exist(LFDDir & "DFBRIEF.LFD") then
	    system("del " & LFDDir & "DFBRIEF.LFD", 2)
	end if
	system("rename " & LFDDir & "DFBRIEF.DFE " & LFDDir & "DFBRIEF.LFD", 2)
    end if
    if exist(LFDDir & "FTEXTCRA.DFE") then
	if not compare(get_position(), {25, 1}) then
	    scroll(1, 2, 25)
	    position(24, 1)
	end if
	puts(1, "Restoring FTEXTCRA.LFD...\n")
	if exist(LFDDir & "FTEXTCRA.LFD") then
	    system("del " & LFDDir & "FTEXTCRA.LFD", 2)
	end if
	system("rename " & LFDDir & "FTEXTCRA.DFE " & LFDDir & "FTEXTCRA.LFD", 2)
    end if
    if not compare(get_position(), {25, 1}) then
	scroll(1, 2, 25)
	position(24, 1)
    end if
    puts(1, "Checking command line params...\n")
    if CMDFind("smileypaper") then
	PaperFile = "EXTRA.SRN"
    end if
    if not compare(get_position(), {25, 1}) then
	scroll(1, 2, 25)
	position(24, 1)
    end if
    puts(1, "Loading wallpaper...\n")
    Wallpaper = LoadSRN(PaperFile)
    if not compare(Wallpaper, {0}) then
	if not compare(get_position(), {25, 1}) then
	    scroll(1, 2, 25)
	    position(24, 1)
	end if
	text_color(12)
	printf(2, "Ack!  %s could not be found!  I'll make do with a solid" &
	    " \'paper.\n", {PaperFile})
	text_color(7)
	Wallpaper = {}
	for i = 1 to (80 * 24) do
	    Wallpaper &= {176, 28}
	end for
    end if
    if not compare(get_position(), {25, 1}) then
	scroll(1, 2, 25)
	position(24, 1)
    end if
    puts(1, "Done!  Ready to bring up the menu-thingy...\n")
end procedure

procedure DrawWallpaper(integer firstrowdraw)
    if firstrowdraw = FALSE then
	poke(VideoMem + 160, Wallpaper[161..length(Wallpaper)])
    else
	poke(VideoMem, Wallpaper)
    end if
end procedure

procedure DrawOptions(integer x1, integer y1, integer x2)
    text_color(7)
    bk_color(1)
    position(y1 + 1, x1 + 1)
    puts(2, "͸ ")
    position(y1 + 1, 33)
    puts(2, "͸ ")
    text_color(0)
    position(y1 + 1, x2 - 12)
    puts(2, "͸")
    text_color(7)
    position(y1 + 2, x1 + 1)
    puts(2, "          ")
    position(y1 + 2, 33)
    puts(2, "              ")
    text_color(0)
    position(y1 + 2, x2 - 12)
    puts(2, "          ")
    text_color(10)
    position(y1 + 2, x1 + 3)
    puts(2, 17 & "      " & 16)
    position(y1 + 2, 35)
    puts(2, 17 & "         " & 16)
    position(y1 + 2, x2 - 10)
    puts(2, 17 & "      " & 16)
    text_color(15)
    position(y1 + 2, x1 + 5)
    puts(2, "Play")
    position(y1 + 2, 37)
    puts(2, "Options")
    position(y1 + 2, x2 - 8)
    puts(2, "Quit")
    text_color(7)
    position(y1 + 3, x1 + 1)
    puts(2, "; ")
    position(y1 + 3, 33)
    puts(2, "; ")
    text_color(0)
    position(y1 + 3, x2 - 12)
    puts(2, ";")
end procedure

procedure DrawNames(integer Start, integer x1, integer y1, integer x2)
    text_color(9)
    bk_color(1)
    for i = Start to Start + NumTitles - 1 do
	position(y1 + (i - Start), x1 - 1)
	puts(2, " " & trim(DFGameData[i][GameName]) & repeat(' ', x2 - x1 -
	    length(trim(DFGameData[i][GameName])) + 1))
    end for
end procedure

function MainWindow()
    integer WindWidth, x1, y1, x2, y2, j, Game, temp, Key
    WindWidth = 0
    
    for i = 1 to length(DFGameData) do
	if length(trim(DFGameData[i][GameName])) > WindWidth then
	    WindWidth = length(trim(DFGameData[i][GameName])) + 1
	end if
    end for
    if WindWidth < 39 then
	WindWidth = 39
    end if
    x1 = floor((80 - (WindWidth + 4)) / 2) + 1
    y1 = floor((25 - (6 + NumTitles)) / 2) + 1
    x2 = 80 - x1
    y2 = 25 - y1
    if floor(NumTitles / 2) != NumTitles / 2 then
	y2 += 1
    end if
    MakeWindow(x1, y1, x2, y2, 15, 1)
    text_color(15)
    bk_color(1)
    position(y1 + 4, x1)
    puts(2, "" & repeat('', x2 - x1 - 1) & "")
    j = 0
    DrawOptions(x1, y1, x2)
    DrawNames(1, x1 + 2, y1 + 5, x2 - 1)
    Game = 1
    while 1 do
	if j = 0 then
	    text_color(14)
	    bk_color(1)
	    position(y1 + 1, x1 + 1)
	    puts(2, "͸ ")
	    position(y1 + 2, x1 + 1)
	    puts(2, " ")
	    text_color(10)
	    puts(2, {17})
	    text_color(15)
	    puts(2, " PLAY ")
	    text_color(10)
	    puts(2, {16})
	    text_color(14)
	    puts(2, "  ")
	    position(y1 + 3, x1 + 1)
	    puts(2, "; ")
	elsif j = 1 then
	    text_color(14)
	    bk_color(1)
	    position(y1 + 1, 33)
	    puts(2, "͸ ")
	    position(y1 + 2, 33)
	    puts(2, " ")
	    text_color(10)
	    puts(2, {17})
	    text_color(15)
	    puts(2, " OPTIONS ")
	    text_color(10)
	    puts(2, {16})
	    text_color(14)
	    puts(2, "  ")
	    position(y1 + 3, 33)
	    puts(2, "; ")
	elsif j = 2 then
	    text_color(14)
	    bk_color(1)
	    position(y1 + 1, x2 - 12)
	    puts(2, "͸")
	    position(y1 + 2, x2 - 12)
	    puts(2, " ")
	    text_color(10)
	    puts(2, {17})
	    text_color(15)
	    puts(2, " QUIT ")
	    text_color(10)
	    puts(2, {16})
	    text_color(14)
	    puts(2, " ")
	    position(y1 + 3, x2 - 12)
	    puts(2, ";")
	end if
	text_color(14)
	bk_color(5)
	if Game < floor(NumTitles / 2) + 1 then
	    position(y1 + 4 + Game, x1 + 1)
	elsif Game > length(DFGameData) - floor(NumTitles / 2) then
	    position(y2 - (length(DFGameData) - Game) - 1, x1 + 1)
	else
	    position(y1 + 5 + floor(NumTitles / 2), x1 + 1)
	end if
	puts(2, " " & trim(DFGameData[Game][GameName]) & repeat(' ', x2 - x1 -
	    length(trim(DFGameData[Game][GameName])) - 2))
	Key = get_key()
	if Key = 331 then
	    j -= 1
	    DrawOptions(x1, y1, x2)
	    if j = -1 then
		j = 2
	    end if
	elsif Key = 333 then
	    j += 1
	    DrawOptions(x1, y1, x2)
	    if j = 3 then
		j = 0
	    end if
	elsif Key = 328 then
	    Game -= 1
	    if Game < 1 then
		Game = 1
	    end if
	    if Game < floor(NumTitles / 2) + 1 then
		DrawNames(1, x1 + 2, y1 + 5, x2 - 1)
	    elsif Game > length(DFGameData) - floor(NumTitles / 2) then
		DrawNames(length(DFGameData) - NumTitles + 1, x1 + 2, y1 + 5,
		    x2 - 1)
	    else
		DrawNames(Game - floor(NumTitles / 2), x1 + 2, y1 + 5, x2- 1)
	    end if
	elsif Key = 336 then
	    Game += 1
	    if Game > length(DFGameData) then
		Game = length(DFGameData)
	    end if
	    if Game < floor(NumTitles / 2) + 1 then
		DrawNames(1, x1 + 2, y1 + 5, x2 - 1)
	    elsif Game > length(DFGameData) - floor(NumTitles / 2) then
		DrawNames(length(DFGameData) - NumTitles + 1, x1 + 2, y1 + 5,
		    x2 - 1)
	    else
		DrawNames(Game - floor(NumTitles / 2), x1 + 2, y1 + 5, x2- 1)
	    end if
	elsif Key = 329 then
	    Game -= 15
	    if Game < 1 then
		Game = 1
	    end if
	    if Game < floor(NumTitles / 2) + 1 then
		DrawNames(1, x1 + 2, y1 + 5, x2 - 1)
	    elsif Game > length(DFGameData) - floor(NumTitles / 2) then
		DrawNames(length(DFGameData) - NumTitles + 1, x1 + 2, y1 + 5,
		    x2 - 1)
	    else
		DrawNames(Game - 7, x1 + 2, y1 + 5, x2- 1)
	    end if
	elsif Key = 337 then
	    Game += 15
	    if Game > length(DFGameData) then
		Game = length(DFGameData)
	    end if
	    if Game < floor(NumTitles / 2) + 1 then
		DrawNames(1, x1 + 2, y1 + 5, x2 - 1)
	    elsif Game > length(DFGameData) - floor(NumTitles / 2) then
		DrawNames(length(DFGameData) - NumTitles + 1, x1 + 2, y1 + 5,
		    x2 - 1)
	    else
		DrawNames(Game - 7, x1 + 2, y1 + 5, x2- 1)
	    end if
	elsif Key = 27 then
	    if j != 2 then
		j = 2
		DrawOptions(x1, y1, x2)
	    else
		text_color(7)
		bk_color(0)
		clear_screen()
		DrawTitleBar(3)
		text_color(7)
		bk_color(0)
		puts(2, "\n")
		cursor(UNDERLINE_CURSOR)
		abort(0)
	    end if
	elsif Key = 13 or Key = 32 then
	    if j = 2 then
		text_color(7)
		bk_color(0)
		clear_screen()
		DrawTitleBar(3)
		text_color(7)
		bk_color(0)
		puts(2, "\n")
		cursor(UNDERLINE_CURSOR)
		abort(0)
	    elsif j = 1 then
		DrawWallpaper(0)
		return(-1)
	    elsif j = 0 then
		DrawWallpaper(0)
		return(Game)
	    end if
	elsif Key = 303 then
	    return -2
	end if
    end while
end function

procedure PlayGame(integer Game)
    sequence MyDir
    MyDir = current_dir()

    text_color(7)
    bk_color(0)
    clear_screen()
    DrawTitleBar(4)
    puts(2, "\n")
    cursor(UNDERLINE_CURSOR)
    if not compare(DFGameData[Game][GOBName], "۲Dark") then
	if chdir(DarkDir) then end if
	if system_exec("dark.exe -shots", 0) then end if
	if chdir(MyDir) then end if
	cursor(NO_CURSOR)
	DrawTitleBar(0)
	DrawWallpaper(0)
	return
    end if
    if chdir(LevelsDir & "\\" & trim(DFGameData[Game][GOBName])) then end if
    system("copy " & trim(DFGameData[Game][GOBName] & ".GOB " & DarkDir), 2)
    if chdir(LFDDir) then end if
    if compare(trim(DFGameData[Game][LFDName]), "") then
	system("rename DFBRIEF.LFD DFBRIEF.DFE", 2)
	system("copy " & LevelsDir & "\\" & DFGameData[Game][GOBName] & "\\" &
	    trim(DFGameData[Game][LFDName]) & ".LFD .", 2)
	system("rename " & trim(DFGameData[Game][LFDName]) & ".LFD DFBRIEF.LFD",
	    2)
    end if
    if compare(trim(DFGameData[Game][CRAWLName]), "") then
	system("rename FTEXTCRA.LFD FTEXTCRA.DFE", 2)
	system("copy " & LevelsDir & "\\" & DFGameData[Game][GOBName] & "\\" &
	    trim(DFGameData[Game][CRAWLName]) & ".LFD .", 2)
	system("rename " & trim(DFGameData[Game][CRAWLName]) &
	    ".LFD FTEXTCRA.LFD", 2)
    end if
    if chdir(LevelsDir & "\\" & trim(DFGameData[Game][GOBName])) then end if
    for i = 1 to DFGameData[Game][OtherNum] do
	system("copy " & DFGameData[Game][OtherNum + i] & " " & DarkDir, 2)
    end for
    if chdir(DarkDir) then end if
    if system_exec("dark -u" & trim(DFGameData[Game][GOBName] & ".GOB - shots"),
	2) then end if
    system("del " & trim(DFGameData[Game][GOBName] & ".GOB"), 2)
    for i = 1 to DFGameData[Game][OtherNum] do
	system("del " & DFGameData[Game][OtherNum + i], 2)
    end for
    if chdir(LFDDir) then end if
    if compare(trim(DFGameData[Game][LFDName]), "") then
	system("del DFBRIEF.LFD", 2)
	system("rename DFBRIEF.DFE DFBRIEF.LFD", 2)
    end if
    if compare(trim(DFGameData[Game][CRAWLName]), "") then
	system("del FTEXTCRA.LFD", 2)
	system("rename FTEXTCRA.DFE FTEXTCRA.LFD", 2)
    end if
    if chdir(MyDir) then end if
    cursor(NO_CURSOR)
    DrawTitleBar(0)
    DrawWallpaper(0)
end procedure

integer hmm, Key

cursor(NO_CURSOR)
clear_screen()
ScreenTests()
DrawTitleBar(0)
DrawWallpaper(0)
while 1 do
    hmm = MainWindow()
    if hmm = -1 then
	Options()
    elsif hmm = -2 then
	DrawWallpaper(1)
	Key = -1
	while Key = -1 do
	    Key = get_key()
	end while
	DrawTitleBar(0)
    else        
	PlayGame(hmm)
    end if
end while
